unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ExtCtrls, Vcl.Buttons,
  math, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Shape1: TShape;
    Timer1: TTimer;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
     y           : integer;
     y0,v0,g     : single;
     yy,vv,t,dt  : single;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  y0 := Shape1.Top;
  v0 := 10.0;
  g  := 9.8;
  t  := 0;
  dt := 50/1000;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  t  := t + dt;
  vv := - v0*t;
  yy := 420  - y0 + 10*( vv + 0.5*g*t*t) ;

  Shape1.Top := ceil(yy);
  Label1.Caption := IntToStr( ceil(yy));
  Label2.Caption := IntToStr( ceil(vv));
  Label3.Caption := IntToStr( ceil(1000*t));

//  sleep(100);
  if (yy+20>420) then begin
    v0 := -vv;
    y0 := 0.0;
    t := dt;
  end;
  
end;

end.
